/*
 * ThreadOptimum.java
 *
 * Created on March 5, 2007, 5:42 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package nl.uu.chem.bioinformatics.statquant.util;
import java.lang.management.*;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.atomic.AtomicLong;

public class ThreadOptimum {
    private static final int THREADS = 20;
    private static CountDownLatch ct = new CountDownLatch(THREADS);
    private static AtomicLong total = new AtomicLong();
    private static Integer measuredProcessors = null;
    
    
    public static Integer measure() throws InterruptedException {
        if (measuredProcessors == null) {
            long elapsedTime = System.nanoTime();
            for (int i = 0; i < THREADS; i++) {
                Thread thread = new Thread() {
                    @Override
                    public void run() {
                        total.addAndGet(measureThreadCpuTime());
                        ct.countDown();
                    }
                };
                thread.start();
            }
            ct.await();
            elapsedTime = System.nanoTime() - elapsedTime;
            
            double factor = total.get();
            factor /= elapsedTime;
            
            measuredProcessors = new Integer((int)(factor + .5));
            if (measuredProcessors == 0) measuredProcessors = 1;
        }
        return measuredProcessors ;
    }
    
    private static void reset() {
        measuredProcessors = null;
    }
    
    private static long measureThreadCpuTime() {
        ThreadMXBean tm = ManagementFactory.getThreadMXBean();
        long cpuTime = tm.getCurrentThreadCpuTime();
        for (int i = 0; i < 1000 * 1000 * 1000; i++) {
            // keep ourselves busy for a while ...
        }
        cpuTime = tm.getCurrentThreadCpuTime() - cpuTime;

        return cpuTime;
    }
}
